/**
 * ETH Zrich; Leitprogramm; Binre Suchbume ----- 
 * Das ist die Klasse eines einzelnen Knotens des Binrbaums. 
 * @author Bjrn Steffen, Timur Erdag, Christina Class
 * @version 1.0 
 */
public class BinaryNode {
    private int key;
    private BinaryNode left, right;
    
    public BinaryNode( int key ) {
        this.key = key;
        left=null;
        right=null;
    }
    
    public BinaryNode( int key, BinaryNode left, BinaryNode right ) {
        this.key = key;
        this.left = left;
        this.right = right;
    }
    
    /**
     * getter Methode fr den Schlssel
     * @return den Schlsselwert
     */
    public int getKey()
    {
        return key;
    }
    
    /**
     * setter Methode fr den Schlssel
     * @param value der neue Schlsselwert
     */
    public void setKey(int value)
    {
        key = value;
    }
    
    
    /**
     * getter Methode fr das rechte Kind
     * @return rechtes Kind
     */
    public BinaryNode getRight()
    {
        return right;
    }
    
    /**
     * setter Methode fr das rechte Kind
     * @param newRight Referenz auf neues rechtes Kind
     */
    public void setRight(BinaryNode newRight)
    {
        right=newRight;
    }
    
    /**
     * getter Methode fr das linke Kind
     * @return linkes Kind
     */
    public BinaryNode getLeft()
    {
        return left;
    }
    
    /**
     * setter Methode fr das linke Kind
     * @param newLeft Referenz auf neues linkes Kind
     */
    public void setLeft(BinaryNode newLeft)
    {
        left=newLeft;
    }
    
    /**
     * Ausgabe des Binrbaumes in der preorder Reihenfolge. Diese Methode 
     * ist von Ihnen in Aufgabe 3.3 des Leitprogramms zu implementieren.
     */
    // Implementiere diese Methode nach den Vorgaben der Aufgabe.
    // Geben Sie dazu fr jeden Knoten den Schlssel aus,
    // gefolgt von einem Leerzeichen.
    // beachten Sie: der Algrithmus, der auf S. 27 des Leitprogramms beschrieben
    // ist, hat einen Parameter (vom Typ Knoten).
    // Sie mssen also eine weitere Methode preorder() definieren, und diese in 
    // preorderPrint() aufrufen
    // fr eine Ausgabe OHNE anschliessenden Zeilenumbruch verwenden Sie bitte:
    // System.out.print()
    
    public void preorderPrint() 
    {   
    }
}

